Index: issm/trunk/src/c/python/io/FetchPythonData.cpp
===================================================================
--- issm/trunk/src/c/python/io/FetchPythonData.cpp	(revision 12709)
+++ issm/trunk/src/c/python/io/FetchPythonData.cpp	(revision 13395)
@@ -15,4 +15,6 @@
 #include "../../include/include.h"
 #include "../../shared/shared.h"
+#include "../../io/io.h"
+void FetchData(char** pstring,PyObject* py_string);
 
 /*Primitive data types*/
@@ -47,5 +49,5 @@
 	
 	/*check this is indeed a subtype of long type: */
-	if(!PyBool_Check(py_boolean))_error2_("expecting a boolean in input!");
+	if(!PyBool_Check(py_boolean))_error_("expecting a boolean in input!");
 
 	/*extract boolean: */
@@ -61,4 +63,5 @@
 
 	/*output: */
+	double* dmatrix=NULL;
 	double* matrix=NULL;
 	int M,N;
@@ -68,10 +71,14 @@
 	/*retrive dimensions: */
 	ndim=PyArray_NDIM((const PyArrayObject*)py_matrix);
-	if(ndim!=2)_error2_("expecting an MxN matrix in input!");
+	if(ndim!=2)_error_("expecting an MxN matrix in input!");
 	dims=PyArray_DIMS((PyArrayObject*)py_matrix);
 	M=dims[0]; N=dims[1];
 	
 	/*retrieve internal value: */
-	matrix=(double*)PyArray_DATA((PyArrayObject*)py_matrix);
+	dmatrix=(double*)PyArray_DATA((PyArrayObject*)py_matrix);
+
+	/*copy matrix: */
+	matrix=xNew<double>(M*N);
+	memcpy(matrix,dmatrix,(M*N)*sizeof(double));
 
 	/*output: */
@@ -81,8 +88,41 @@
 }
 /*}}}*/
+/*FUNCTION FetchData(int** pmatrix,int* pM, int* pN, PyObject* py_matrix){{{*/
+void FetchData(int** pmatrix,int* pM,int *pN,PyObject* py_matrix){
+
+	/*output: */
+	double* dmatrix=NULL;
+	int* matrix=NULL;
+	int M,N;
+
+	/*intermediary:*/
+	int i;
+	int ndim;
+	npy_intp*  dims=NULL;
+
+	/*retrive dimensions: */
+	ndim=PyArray_NDIM((const PyArrayObject*)py_matrix);
+	if(ndim!=2)_error_("expecting an MxN matrix in input!");
+	dims=PyArray_DIMS((PyArrayObject*)py_matrix);
+	M=dims[0]; N=dims[1];
+	
+	/*retrieve internal value: */
+	dmatrix=(double*)PyArray_DATA((PyArrayObject*)py_matrix);
+
+	/*transform into integer matrix: */
+	matrix=xNew<int>(M*N);
+	for(i=0;i<M*N;i++)matrix[i]=(int)dmatrix[i];
+
+	/*output: */
+	if(pM)*pM=M;
+	if(pN)*pN=N;
+	if(pmatrix)*pmatrix=matrix;
+}
+/*}}}*/
 /*FUNCTION FetchData(double** pvector,int* pM, PyObject* py_vector){{{*/
 void FetchData(double** pvector,int* pM,PyObject* py_vector){
 
 	/*output: */
+	double* dvector=NULL;
 	double* vector=NULL;
 	int M;
@@ -92,14 +132,180 @@
 	/*retrive dimensions: */
 	ndim=PyArray_NDIM((const PyArrayObject*)py_vector);
-	if(ndim!=1)_error2_("expecting an Mx1 vector in input!");
+	if(ndim!=1)_error_("expecting an Mx1 vector in input!");
 	dims=PyArray_DIMS((PyArrayObject*)py_vector);
 	M=dims[0]; 
 	
 	/*retrieve internal value: */
-	vector=(double*)PyArray_DATA((PyArrayObject*)py_vector);
+	dvector=(double*)PyArray_DATA((PyArrayObject*)py_vector);
+
+	/*copy vector: */
+	vector=xNew<double>(M);
+	memcpy(vector,dvector,(M)*sizeof(double));
 
 	/*output: */
 	if(pM)*pM=M;
 	if(pvector)*pvector=vector;
+}
+/*}}}*/
+
+/*ISSM objects*/
+/*FUNCTION FetchData(BamgGeom** pbamggeom,PyObject* py_dict){{{*/
+void FetchData(BamgGeom** pbamggeom,PyObject* py_dict){
+
+	/*Initialize output*/
+	BamgGeom* bamggeom=new BamgGeom();
+
+	/*Fetch all fields*/
+	FetchData(&bamggeom->Vertices,&bamggeom->VerticesSize[0],&bamggeom->VerticesSize[1],PyDict_GetItemString(py_dict,"Vertices"));
+	FetchData(&bamggeom->Edges, &bamggeom->EdgesSize[0], &bamggeom->EdgesSize[1], PyDict_GetItemString(py_dict,"Edges"));
+	FetchData(&bamggeom->Corners, &bamggeom->CornersSize[0], &bamggeom->CornersSize[1], PyDict_GetItemString(py_dict,"Corners"));
+	FetchData(&bamggeom->RequiredVertices,&bamggeom->RequiredVerticesSize[0],&bamggeom->RequiredVerticesSize[1],PyDict_GetItemString(py_dict,"RequiredVertices"));
+	FetchData(&bamggeom->RequiredEdges, &bamggeom->RequiredEdgesSize[0], &bamggeom->RequiredEdgesSize[1], PyDict_GetItemString(py_dict,"RequiredEdges"));
+	FetchData(&bamggeom->CrackedEdges,&bamggeom->CrackedEdgesSize[0],&bamggeom->CrackedEdgesSize[1],PyDict_GetItemString(py_dict,"CrackedEdges"));
+	FetchData(&bamggeom->SubDomains,&bamggeom->SubDomainsSize[0],&bamggeom->SubDomainsSize[1],PyDict_GetItemString(py_dict,"SubDomains"));
+
+	/*Assign output pointers:*/
+	*pbamggeom=bamggeom;
+}
+/*}}}*/
+/*FUNCTION FetchData(BamgMesh** pbamgmesh,PyObject* py_dict){{{*/
+void FetchData(BamgMesh** pbamgmesh,PyObject* py_dict){
+
+	/*Initialize output*/
+	BamgMesh* bamgmesh=new BamgMesh();
+
+	/*Fetch all fields*/
+	FetchData(&bamgmesh->Vertices,&bamgmesh->VerticesSize[0],&bamgmesh->VerticesSize[1],PyDict_GetItemString(py_dict,"Vertices"));
+	FetchData(&bamgmesh->Edges, &bamgmesh->EdgesSize[0], &bamgmesh->EdgesSize[1], PyDict_GetItemString(py_dict,"Edges"));
+	FetchData(&bamgmesh->Triangles, &bamgmesh->TrianglesSize[0], &bamgmesh->TrianglesSize[1], PyDict_GetItemString(py_dict,"Triangles"));
+	FetchData(&bamgmesh->CrackedEdges,&bamgmesh->CrackedEdgesSize[0],&bamgmesh->CrackedEdgesSize[1],PyDict_GetItemString(py_dict,"CrackedEdges"));
+	FetchData(&bamgmesh->VerticesOnGeomEdge,&bamgmesh->VerticesOnGeomEdgeSize[0],&bamgmesh->VerticesOnGeomEdgeSize[1],PyDict_GetItemString(py_dict,"VerticesOnGeomEdge"));
+	FetchData(&bamgmesh->VerticesOnGeomVertex,&bamgmesh->VerticesOnGeomVertexSize[0],&bamgmesh->VerticesOnGeomVertexSize[1],PyDict_GetItemString(py_dict,"VerticesOnGeomVertex"));
+	FetchData(&bamgmesh->EdgesOnGeomEdge, &bamgmesh->EdgesOnGeomEdgeSize[0], &bamgmesh->EdgesOnGeomEdgeSize[1], PyDict_GetItemString(py_dict,"EdgesOnGeomEdge"));
+	FetchData(&bamgmesh->IssmSegments,&bamgmesh->IssmSegmentsSize[0],&bamgmesh->IssmSegmentsSize[1],PyDict_GetItemString(py_dict,"IssmSegments"));
+
+	/*Assign output pointers:*/
+	*pbamgmesh=bamgmesh;
+}
+/*}}}*/
+/*FUNCTION FetchData(BamgOpts** pbamgopts,PyObject* py_dict){{{*/
+void FetchData(BamgOpts** pbamgopts,PyObject* py_dict){
+
+	/*Initialize output*/
+	BamgOpts* bamgopts=new BamgOpts();
+
+	/*Fetch all fields*/
+	FetchData(&bamgopts->anisomax,PyDict_GetItemString(py_dict,"anisomax"));
+	FetchData(&bamgopts->cutoff,PyDict_GetItemString(py_dict,"cutoff"));
+	FetchData(&bamgopts->coeff,PyDict_GetItemString(py_dict,"coeff"));
+	FetchData(&bamgopts->errg,PyDict_GetItemString(py_dict,"errg"));
+	FetchData(&bamgopts->gradation,PyDict_GetItemString(py_dict,"gradation"));
+	FetchData(&bamgopts->Hessiantype,PyDict_GetItemString(py_dict,"Hessiantype"));
+	FetchData(&bamgopts->MaxCornerAngle,PyDict_GetItemString(py_dict,"MaxCornerAngle"));
+	FetchData(&bamgopts->maxnbv,PyDict_GetItemString(py_dict,"maxnbv"));
+	FetchData(&bamgopts->maxsubdiv,PyDict_GetItemString(py_dict,"maxsubdiv"));
+	FetchData(&bamgopts->Metrictype,PyDict_GetItemString(py_dict,"Metrictype"));
+	FetchData(&bamgopts->nbjacobi,PyDict_GetItemString(py_dict,"nbjacobi"));
+	FetchData(&bamgopts->nbsmooth,PyDict_GetItemString(py_dict,"nbsmooth"));
+	FetchData(&bamgopts->omega,PyDict_GetItemString(py_dict,"omega"));
+	FetchData(&bamgopts->power,PyDict_GetItemString(py_dict,"power"));
+	FetchData(&bamgopts->verbose,PyDict_GetItemString(py_dict,"verbose"));
+
+	FetchData(&bamgopts->Crack,PyDict_GetItemString(py_dict,"Crack"));
+	FetchData(&bamgopts->geometricalmetric,PyDict_GetItemString(py_dict,"geometricalmetric"));
+	FetchData(&bamgopts->KeepVertices,PyDict_GetItemString(py_dict,"KeepVertices"));
+	FetchData(&bamgopts->splitcorners,PyDict_GetItemString(py_dict,"splitcorners"));
+
+	FetchData(&bamgopts->hmin,PyDict_GetItemString(py_dict,"hmin"));
+	FetchData(&bamgopts->hmax,PyDict_GetItemString(py_dict,"hmax"));
+	FetchData(&bamgopts->hminVertices,&bamgopts->hminVerticesSize[0],&bamgopts->hminVerticesSize[1],PyDict_GetItemString(py_dict,"hminVertices"));
+	FetchData(&bamgopts->hmaxVertices,&bamgopts->hmaxVerticesSize[0],&bamgopts->hmaxVerticesSize[1],PyDict_GetItemString(py_dict,"hmaxVertices"));
+	FetchData(&bamgopts->hVertices,&bamgopts->hVerticesSize[0],&bamgopts->hVerticesSize[1],PyDict_GetItemString(py_dict,"hVertices"));
+	FetchData(&bamgopts->metric,&bamgopts->metricSize[0],&bamgopts->metricSize[1],PyDict_GetItemString(py_dict,"metric"));
+	FetchData(&bamgopts->field,&bamgopts->fieldSize[0],&bamgopts->fieldSize[1],PyDict_GetItemString(py_dict,"field"));
+	FetchData(&bamgopts->err,&bamgopts->errSize[0],&bamgopts->errSize[1],PyDict_GetItemString(py_dict,"err"));
+
+	/*Additional checks*/
+	bamgopts->Check();
+
+	/*Assign output pointers:*/
+	*pbamgopts=bamgopts;
+}
+/*}}}*/
+/*FUNCTION FetchData(Options** poptions,int istart, int nrhs,PyObject* py_tuple){{{*/
+void FetchData(Options** poptions,int istart, int nrhs,PyObject* py_tuple){
+
+	char   *name   = NULL;
+	Option *option = NULL;
+
+	/*Initialize output*/
+	Options* options=new Options();
+
+	/*Fetch all options*/
+	for (int i=istart; i<nrhs; i=i+2){
+		if (!PyString_Check(PyTuple_GetItem(py_tuple,(Py_ssize_t)i))) _error_("Argument " << i+1 << " must be name of option");
+
+		FetchData(&name,PyTuple_GetItem(py_tuple,(Py_ssize_t)i));
+		if(i+1 == nrhs) _error_("Argument " << i+2 << " must exist and be value of option \"" << name << "\".");
+
+		_pprintLine_("FetchData for Options not implemented yet, ignoring option \"" << name << "\"!");
+
+//		option=(Option*)OptionParse(name,&PyTuple_GetItem(py_tuple,(Py_ssize_t)(i+1)));
+//		options->AddOption(option);
+//		option=NULL;
+	}
+
+	/*Assign output pointers:*/
+	*poptions=options;
+}
+/*}}}*/
+/*FUNCTION FetchData(DataSet** pcontours,PyObject* py_list){{{*/
+void FetchData(DataSet** pcontours,PyObject* py_list){
+
+	int              numcontours,test1,test2;
+	char            *contourname = NULL;
+	DataSet         *contours    = NULL;
+	Contour<double> *contouri    = NULL;
+	PyObject        *py_dicti    = NULL;
+	PyObject        *py_item     = NULL;
+
+	if (PyString_Check(py_list)){
+		FetchData(&contourname,py_list);
+		contours=DomainOutlineRead<double>(contourname);
+	}
+	else if(PyList_Check(py_list)){
+
+		contours=new DataSet(0);
+		numcontours=(int)PyList_Size(py_list);
+
+		for(int i=0;i<numcontours;i++){
+
+			contouri=xNew<Contour<double> >(1);
+			py_dicti=PyList_GetItem(py_list,(Py_ssize_t)i);
+
+			py_item = PyDict_GetItemString(py_dicti,"nods");
+			if(!py_item) _error_("input structure does not have a 'nods' field");
+			FetchData(&contouri->nods,py_item);
+
+			py_item = PyDict_GetItemString(py_dicti,"x");
+			if(!py_item) _error_("input structure does not have a 'x' field");
+			FetchData(&contouri->x,&test1,&test2,py_item);
+			if(test1!=contouri->nods || test2!=1) _error_("field x should be of size ["<<contouri->nods<<" 1]");
+
+			py_item = PyDict_GetItemString(py_dicti,"y");
+			if(!py_item) _error_("input structure does not have a 'y' field");
+			FetchData(&contouri->y,&test1,&test2,py_item);
+			if(test1!=contouri->nods || test2!=1) _error_("field y should be of size ["<<contouri->nods<<" 1]");
+
+			contours->AddObject(contouri);
+		}
+	}
+	else{
+		_error_("Contour is neither a string nor a structure and cannot be loaded");
+	}
+
+	/*clean-up and assign output pointer*/
+	xDelete<char>(contourname);
+	*pcontours=contours;
 }
 /*}}}*/
@@ -113,5 +319,4 @@
 	char* string=NULL;
 
-	
 	/*convert to bytes format: */
 	PyUnicode_FSConverter(py_unicode,&py_bytes);
@@ -131,6 +336,8 @@
 	/*extract internal string: */
 	string=PyString_AsString(py_string);
-	
-	*pstring=string;
+
+	/*copy string (note strlen does not include trailing NULL): */
+	*pstring=xNew<char>(strlen(string)+1);
+	memcpy(*pstring,string,(strlen(string)+1)*sizeof(char));
 }
 /*}}}*/
Index: issm/trunk/src/c/python/io/WritePythonData.cpp
===================================================================
--- issm/trunk/src/c/python/io/WritePythonData.cpp	(revision 12709)
+++ issm/trunk/src/c/python/io/WritePythonData.cpp	(revision 13395)
@@ -19,6 +19,13 @@
 #include "../../io/io.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
+PyObject* PyArrayFromCopiedData(int dims[2],double* data);
 
+/*Primitive data types*/
+/*FUNCTION WriteData(PyObject* py_tuple,int index,int integer){{{*/
+void WriteData(PyObject* py_tuple, int index, int integer){
+	
+	PyTuple_SetItem(py_tuple, index, PyInt_FromSsize_t(integer));
 
+}/*}}}*/
 /*FUNCTION WriteData(PyObject* py_tuple,int index,char* string){{{*/
 void WriteData(PyObject* py_tuple, int index, char* string){
@@ -27,6 +34,82 @@
 
 }/*}}}*/
-/*FUNCTION WriteData(PyObject* tuple,int index,Matrix* matrix){{{*/
-void WriteData(PyObject* tuple,int index,Matrix* matrix){
+/*FUNCTION WriteData(PyObject* py_tuple,int index, double* matrix, int M, int N){{{*/
+void WriteData(PyObject* tuple, int index, double* matrix, int M,int N){
+
+	npy_intp dims[2]={0,0};
+	PyObject* array=NULL;
+
+	dims[0]=(npy_intp)M;
+	dims[1]=(npy_intp)N;
+	array=PyArray_SimpleNewFromData(2,dims,NPY_DOUBLE,matrix);
+
+	PyTuple_SetItem(tuple, index, array);
+}/*}}}*/
+
+/*ISSM objects*/
+/*FUNCTION WriteData(PyObject* py_tuple,int index,BamgGeom* bamggeom){{{*/
+void WriteData(PyObject* py_tuple,int index,BamgGeom* bamggeom){
+
+	PyObject* dict=NULL;
+
+	dict=PyDict_New();
+
+	PyDict_SetItemString(dict,"Vertices",PyArrayFromCopiedData(bamggeom->VerticesSize,bamggeom->Vertices));
+	PyDict_SetItemString(dict,"Edges",PyArrayFromCopiedData(bamggeom->EdgesSize,bamggeom->Edges));
+	PyDict_SetItemString(dict,"TangentAtEdges",PyArrayFromCopiedData(bamggeom->TangentAtEdgesSize,bamggeom->TangentAtEdges));
+	PyDict_SetItemString(dict,"Corners",PyArrayFromCopiedData(bamggeom->CornersSize,bamggeom->Corners));
+	PyDict_SetItemString(dict,"RequiredVertices",PyArrayFromCopiedData(bamggeom->RequiredVerticesSize,bamggeom->RequiredVertices));
+	PyDict_SetItemString(dict,"RequiredEdges",PyArrayFromCopiedData(bamggeom->RequiredEdgesSize,bamggeom->RequiredEdges));
+	PyDict_SetItemString(dict,"CrackedEdges",PyArrayFromCopiedData(bamggeom->CrackedEdgesSize,bamggeom->CrackedEdges));
+	PyDict_SetItemString(dict,"SubDomains",PyArrayFromCopiedData(bamggeom->SubDomainsSize,bamggeom->SubDomains));
+
+	PyTuple_SetItem(py_tuple, index, dict);
+}
+/*}}}*/
+/*FUNCTION WriteData(PyObject* py_tuple,int index,BamgMesh* bamgmesh){{{*/
+void WriteData(PyObject* py_tuple,int index,BamgMesh* bamgmesh){
+
+	PyObject* dict=NULL;
+
+	dict=PyDict_New();
+
+	PyDict_SetItemString(dict,"Vertices",PyArrayFromCopiedData(bamgmesh->VerticesSize,bamgmesh->Vertices));
+	PyDict_SetItemString(dict,"Edges",PyArrayFromCopiedData(bamgmesh->EdgesSize,bamgmesh->Edges));
+	PyDict_SetItemString(dict,"Triangles",PyArrayFromCopiedData(bamgmesh->TrianglesSize,bamgmesh->Triangles));
+	PyDict_SetItemString(dict,"Quadrilaterals",PyArrayFromCopiedData(bamgmesh->QuadrilateralsSize,bamgmesh->Quadrilaterals));
+	PyDict_SetItemString(dict,"IssmEdges",PyArrayFromCopiedData(bamgmesh->IssmEdgesSize,bamgmesh->IssmEdges));
+	PyDict_SetItemString(dict,"IssmSegments",PyArrayFromCopiedData(bamgmesh->IssmSegmentsSize,bamgmesh->IssmSegments));
+	PyDict_SetItemString(dict,"VerticesOnGeomVertex",PyArrayFromCopiedData(bamgmesh->VerticesOnGeomVertexSize,bamgmesh->VerticesOnGeomVertex));
+	PyDict_SetItemString(dict,"VerticesOnGeomEdge",PyArrayFromCopiedData(bamgmesh->VerticesOnGeomEdgeSize,bamgmesh->VerticesOnGeomEdge));
+	PyDict_SetItemString(dict,"EdgesOnGeomEdge",PyArrayFromCopiedData(bamgmesh->EdgesOnGeomEdgeSize,bamgmesh->EdgesOnGeomEdge));
+	PyDict_SetItemString(dict,"SubDomains",PyArrayFromCopiedData(bamgmesh->SubDomainsSize,bamgmesh->SubDomains));
+	PyDict_SetItemString(dict,"SubDomainsFromGeom",PyArrayFromCopiedData(bamgmesh->SubDomainsFromGeomSize,bamgmesh->SubDomainsFromGeom));
+	PyDict_SetItemString(dict,"ElementConnectivity",PyArrayFromCopiedData(bamgmesh->ElementConnectivitySize,bamgmesh->ElementConnectivity));
+	PyDict_SetItemString(dict,"NodalConnectivity",PyArrayFromCopiedData(bamgmesh->NodalConnectivitySize,bamgmesh->NodalConnectivity));
+	PyDict_SetItemString(dict,"NodalElementConnectivity",PyArrayFromCopiedData(bamgmesh->NodalElementConnectivitySize,bamgmesh->NodalElementConnectivity));
+	PyDict_SetItemString(dict,"CrackedVertices",PyArrayFromCopiedData(bamgmesh->CrackedVerticesSize,bamgmesh->CrackedVertices));
+	PyDict_SetItemString(dict,"CrackedEdges",PyArrayFromCopiedData(bamgmesh->CrackedEdgesSize,bamgmesh->CrackedEdges));
+
+	PyTuple_SetItem(py_tuple, index, dict);
+}
+/*}}}*/
+/*FUNCTION PyArrayFromCopiedData(int dims[2],double* data){{{*/
+PyObject* PyArrayFromCopiedData(int dims[2],double* data){
+
+	double* pydata;
+	npy_intp pydims[2]={0,0};
+
+	/*  note that PyArray_SimpleNewFromData does not copy the data, so that when the original
+	object (e.g. bamggeom,bamgmesh) is deleted, the data is gone.  */
+
+	pydims[0]=(npy_intp)dims[0];
+	pydims[1]=(npy_intp)dims[1];
+	pydata=xNew<IssmDouble>(dims[0]*dims[1]);
+	memcpy(pydata,data,dims[0]*dims[1]*sizeof(double));
+	return PyArray_SimpleNewFromData(2,pydims,NPY_DOUBLE,pydata);
+}
+/*}}}*/
+/*FUNCTION WriteData(PyObject* py_tuple,int index,SeqMat<double>* matrix){{{*/
+void WriteData(PyObject* py_tuple,int index,SeqMat<double>* matrix){
 	
 	int M,N;
@@ -41,10 +124,9 @@
 	array=PyArray_SimpleNewFromData(2,dims,NPY_DOUBLE,buffer);
 	
-	PyTuple_SetItem(tuple, index, array);
-
+	PyTuple_SetItem(py_tuple, index, array);
 
 }/*}}}*/
-/*FUNCTION WriteData(PyObject* py_tuple,int index,Vector* vector){{{*/
-void WriteData(PyObject* tuple,int index,Vector* vector){
+/*FUNCTION WriteData(PyObject* py_tuple,int index,SeqVec<double>* vector){{{*/
+void WriteData(PyObject* tuple,int index,SeqVec<double>* vector){
 	
 	int M;
@@ -59,19 +141,4 @@
 	
 	PyTuple_SetItem(tuple, index, array);
-
-
 }
 /*}}}*/
-/*FUNCTION WriteData(PyObject* py_tuple,int index, double* matrix, int M, int N){{{*/
-void WriteData(PyObject* tuple, int index, double* matrix, int M,int N){
-	
-	npy_intp dims[2]={0,0};
-	PyObject* array=NULL;
-	
-	dims[0]=(npy_intp)M;
-	dims[1]=(npy_intp)N;
-	array=PyArray_SimpleNewFromData(2,dims,NPY_DOUBLE,matrix);
-	
-	PyTuple_SetItem(tuple, index, array);
-
-}/*}}}*/
Index: issm/trunk/src/c/python/io/pythonio.h
===================================================================
--- issm/trunk/src/c/python/io/pythonio.h	(revision 12709)
+++ issm/trunk/src/c/python/io/pythonio.h	(revision 13395)
@@ -12,43 +12,28 @@
 #endif 
 
-
-#include "../../objects/objects.h"
+#include "../../classes/classes.h"
 #include "../../Container/Container.h"
 #include "../../include/include.h"
 
-class DataSet;
-class Parameters;
+void WriteData(PyObject* py_tuple,int index, double* matrix, int M,int N);
+void WriteData(PyObject* py_tuple,int index, int integer);
+void WriteData(PyObject* py_tuple,int index, char* string);
+void WriteData(PyObject* py_tuple,int index, SeqMat<double>* matrix);
+void WriteData(PyObject* py_tuple,int index, SeqVec<double>* vector);
+void WriteData(PyObject* py_tuple,int index, BamgGeom* bamggeom);
+void WriteData(PyObject* py_tuple,int index, BamgMesh* bamgmesh);
 
-//void WriteData(PyObject* py_tuple,DataSet* dataset);
-//void WriteData(PyObject* py_tuple,int*    matrix, int M,int N);
-//void WriteData(PyObject* py_tuple,double* vector, int M);
-//void WriteData(PyObject* py_tuple,int integer);
-//void WriteData(PyObject* py_tuple,bool boolean);
-//void WriteData(PyObject* py_tuple,double scalar);
-//void WriteData(DataHandle* py_tuple,Parameters* parameters);
-void WriteData(PyObject* py_tuple, int index, double* matrix, int M,int N);
-void WriteData(PyObject* py_tuple, int index, char* string);
-void WriteData(PyObject* py_tuple, int index, Matrix* matrix);
-void WriteData(PyObject* py_tuple, int index, Vector* vector);
-
-
-//void FetchData(DataSet** pdataset,PyObject* py_ref);
-//void FetchData(double** pmatrix,int* pnumel,int* pndims,int** psize,PyObject* py_ref);
-//void FetchData(int** pmatrix,int* pM,int *pN,PyObject* py_ref);
-//void FetchData(bool** pmatrix,int* pM,int *pN,PyObject* py_ref);
-//void FetchData(bool** pmatrix,int* pnumel,int* pndims,int** psize,PyObject* py_ref);
-//void FetchData(Matrix** pmatrix,PyObject* py_ref);
-//void FetchData(int** pvector,int* pM,PyObject* py_ref);
-//void FetchData(float** pvector,int* pM,PyObject* py_ref);
-//void FetchData(bool** pvector,int* pM,PyObject* py_ref);
-//void FetchData(Vector** pvector,PyObject* py_ref);
-//void FetchData(char** pmatrix,int* pnumel,int* pndims,int** psize,PyObject* py_ref);
-//void FetchData(Parameters** pparameters, DataHandle py_ref);
 void FetchData(double** pvector,int* pM,PyObject* py_ref);
 void FetchData(double** pmatrix,int* pM,int *pN,PyObject* py_array);
+void FetchData(int** pmatrix,int* pM,int *pN,PyObject* py_matrix);
 void FetchData(char** pstring,PyObject* py_unicode);
 void FetchData(double* pscalar,PyObject* py_float);
 void FetchData(int* pinteger,PyObject* py_long);
 void FetchData(bool* pbool,PyObject* py_boolean);
+void FetchData(BamgGeom** bamggeom,PyObject* py_dict);
+void FetchData(BamgMesh** bamgmesh,PyObject* py_dict);
+void FetchData(BamgOpts** bamgopts,PyObject* py_dict);
+void FetchData(Options** poptions,int istart, int nrhs,PyObject* py_tuple);
+void FetchData(DataSet** pcontours,PyObject* py_list);
 
 int CheckNumPythonArguments(PyObject* inputs,int NRHS, void (*function)( void ));
Index: issm/trunk/src/c/shared/Alloc/alloc.cpp
===================================================================
--- issm/trunk/src/c/shared/Alloc/alloc.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Alloc/alloc.cpp	(revision 13395)
@@ -25,42 +25,7 @@
 #include "../Exceptions/exceptions.h"
 #include "../../include/include.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
-void* xmalloc(int size){
-
-	void* memptr=NULL;
-
-	if(!size)_error2_("attempting to 0 size allocation!");
-
-	/* Use the c library to do the allocation: */
-	memptr=malloc(size);
-	if(!memptr) _error2_("memory allocation failed!");
-
-	return memptr;
-}
-
-void* xcalloc(int n,int size){
-
-	void* memptr=NULL;
-	
-	if(!size)_error2_("attempting to 0 size allocation!");
-
-	/* Use the c library to do the allocation: */
-	memptr=calloc(n,size);
-	if(!memptr) _error2_("memory allocation failed!");
-
-	return memptr;
-}
-
-void xfree(void* *pv){
-
-	if (pv && *pv){
-		free(*pv);
-
-		*pv=NULL;
-	}
-}
-
-void xdelete(Matrix** pv){
+void xdelete(Matrix<IssmDouble>** pv){
 	
 	if (pv && *pv){
@@ -73,5 +38,5 @@
 }
 
-void xdelete(Vector** pv){
+void xdelete(Vector<IssmDouble>** pv){
 
 	if (pv && *pv){
@@ -83,15 +48,2 @@
 	}
 }
-
-void* xrealloc( void* pv, int size){
-	
-	register void* value=NULL;
-	
-	if(!size)_error2_("attempting to realloc to zero");
-	value = (void*)realloc(pv,size);
-
-	if (value == NULL) {
-		_error2_("virtual memory exhausted");
-	}
-	return value;
-}
Index: issm/trunk/src/c/shared/Alloc/alloc.h
===================================================================
--- issm/trunk/src/c/shared/Alloc/alloc.h	(revision 12709)
+++ issm/trunk/src/c/shared/Alloc/alloc.h	(revision 13395)
@@ -5,12 +5,11 @@
 #ifndef _ALLOC_H_
 #define _ALLOC_H_
-class Matrix;
-class Vector;
-void* xmalloc(int size);
-void* xcalloc(int n,int size);
-void  xfree(void** pvptr);
-void* xrealloc ( void* pv, int size);
-void xdelete(Matrix** pvptr);
-void xdelete(Vector** pvptr);
 
+#include "../../include/include.h"
+#include "./xNewDelete.h"
+
+template <class doubletype> class Matrix;
+template <class doubletype> class Vector;
+void xdelete(Matrix<IssmDouble>** pvptr);
+void xdelete(Vector<IssmDouble>** pvptr);
 #endif
Index: issm/trunk/src/c/shared/Alloc/xNewDelete.h
===================================================================
--- issm/trunk/src/c/shared/Alloc/xNewDelete.h	(revision 12709)
+++ issm/trunk/src/c/shared/Alloc/xNewDelete.h	(revision 13395)
@@ -34,4 +34,29 @@
 
 template <class T> 
+T** xNew(unsigned int dim1, unsigned int dim2) {
+#ifdef USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
+  T* buf=new T[dim1*dim2];
+  assert(buf );
+  T** aT_pp =new T*[dim1];
+  assert(aT_pp );
+  for (unsigned int i=0;i<dim1;++i) {
+    aT_pp [i]=buf;
+    buf+=dim2;
+  }
+  return aT_pp ;
+#else
+  T* buf=(T*)malloc(dim1*dim2*sizeof(T));
+  assert(buf );
+  T** aT_pp =(T**)malloc(dim1*sizeof(T*));
+  assert(aT_pp );
+  for (unsigned int i=0;i<dim1;++i) {
+    aT_pp [i]=buf;
+    buf+=dim2;
+  }
+  return aT_pp ;
+#endif
+}
+
+template <class T>
 T* xNewZeroInit(unsigned int size) {
 #ifdef USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
@@ -48,5 +73,19 @@
 
 template <class T>
-void xDelete(T*& aT_p) { 
+void xDelete(T**& aT_pp) {
+  if (aT_pp) {
+#ifdef USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
+    delete [](*aT_pp);
+    delete [](aT_pp);
+#else
+    free((void*)*aT_pp)
+    free((void**)aT_pp);
+#endif
+  }
+  aT_pp=0;
+}
+
+template <class T>
+void xDelete(T*& aT_p) {
   if (aT_p) 
 #ifdef USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
@@ -61,34 +100,34 @@
 T* xReNew(T* old, unsigned int old_size, unsigned int size) {
 #ifdef USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
-  T* aT_p=0;
-  if (!old) { // no old memory
-    if (size)  
-      aT_p=xNew<T>(size); // according to realloc behavior in manual page 
-  }
-  else { // have old memory
-    if (!size)  // but 0 size
-      xDelete<T>(old); // according to realloc behavior in manual page
-    else { // non-zero size
-      assert(old_size); // have old memory - need to have old_size set or this call is bad
-      // allocate new, delete old; ; even for the case when size is 
-      // less than old_size we can't just keep the memory unchanged 
-      // because otherwise classes that have ctors/dtors with side-effects 
-      // may misbehave, for example classes with static instance/operations counters. 
-      aT_p=xNew<T>(size);
-      unsigned int iMax=(old_size<size)?old_size:size;
-      for (unsigned int i=0; i<iMax;++i) { 
-	// we need to copy the items by explicit assignments
-	aT_p[i]=old[i];
-      }
-      xDelete<T>(old);
-    }
-  }
-  return aT_p;
+	T* aT_p=0;
+	if (!old) { // no old memory
+		if (size)  
+		 aT_p=xNew<T>(size); // according to realloc behavior in manual page 
+	}
+	else { // have old memory
+		if (!size)  // but 0 size
+		 xDelete<T>(old); // according to realloc behavior in manual page
+		else { // non-zero size
+			assert(old_size); // have old memory - need to have old_size set or this call is bad
+			// allocate new, delete old; ; even for the case when size is 
+			// less than old_size we can't just keep the memory unchanged 
+			// because otherwise classes that have ctors/dtors with side-effects 
+			// may misbehave, for example classes with static instance/operations counters. 
+			aT_p=xNew<T>(size);
+			unsigned int iMax=(old_size<size)?old_size:size;
+			for (unsigned int i=0; i<iMax;++i) { 
+				// we need to copy the items by explicit assignments
+				aT_p[i]=old[i];
+			}
+			xDelete<T>(old);
+		}
+	}
+	return aT_p;
 #else
-  T* aT_p=0;
-  aT_p=(T*)realloc((void*)old,size*sizeof(T));
-  if (size) 
-    assert(aT_p); // according to realloc behavior in manual page
-  return aT_p;
+	T* aT_p=0;
+	aT_p=(T*)realloc((void*)old,size*sizeof(T));
+	if (size) 
+	 assert(aT_p); // according to realloc behavior in manual page
+	return aT_p;
 #endif 
 }
Index: issm/trunk/src/c/shared/Bamg/OppositeAngle.h
===================================================================
--- issm/trunk/src/c/shared/Bamg/OppositeAngle.h	(revision 12709)
+++ issm/trunk/src/c/shared/Bamg/OppositeAngle.h	(revision 13395)
@@ -2,5 +2,5 @@
 #define _OPPOSITEANGLE_H_
 
-#include "../../objects/Bamg/include.h"
+#include "../../classes/bamg/include.h"
 
 /*Return the opposite angle modulo 2 Pi*/
Index: issm/trunk/src/c/shared/Bamg/det.h
===================================================================
--- issm/trunk/src/c/shared/Bamg/det.h	(revision 12709)
+++ issm/trunk/src/c/shared/Bamg/det.h	(revision 13395)
@@ -2,5 +2,5 @@
 #define _BAMGDET_H_
 
-#include "../../objects/Bamg/include.h"
+#include "../../classes/bamg/include.h"
 
 namespace bamg {
Index: issm/trunk/src/c/shared/Elements/ComputeDelta18oTemperaturePrecipitation.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/ComputeDelta18oTemperaturePrecipitation.cpp	(revision 13395)
+++ issm/trunk/src/c/shared/Elements/ComputeDelta18oTemperaturePrecipitation.cpp	(revision 13395)
@@ -0,0 +1,32 @@
+/* file:  ComputeTemperaturePrecipitation.cpp
+   Compute the temperature and precipitation at time t from 
+   the data at present day and delta18O
+ */
+
+#include "./elements.h"
+
+void ComputeDelta18oTemperaturePrecipitation(IssmDouble Delta18oSurfacePresent, IssmDouble Delta18oSurfaceLgm, IssmDouble Delta18oSurfaceTime,
+				     IssmDouble Delta18oPresent, IssmDouble Delta18oLgm, IssmDouble Delta18oTime, 
+				     IssmDouble* PrecipitationsPresentday,
+				     IssmDouble* TemperaturesLgm, IssmDouble* TemperaturesPresentday, 
+				     IssmDouble* monthlytemperaturesout, IssmDouble* monthlyprecout){
+
+  IssmDouble monthlytemperaturestmp[12],monthlyprectmp[12];
+  IssmDouble delta18oLapseRate=-6.2*pow(10.,-3);
+  IssmDouble glacialindex; // used to vary present day temperature
+  int imonth=0;
+
+  glacialindex = 0;//(Delta18oTime-Delta18oPresent-delta18oLapseRate*(Delta18oSurfaceTime-Delta18oSurfacePresent))
+  //  /(Delta18oLgm-Delta18oPresent-delta18oLapseRate*(Delta18oSurfaceLgm-Delta18oSurfacePresent));
+
+  for (int imonth = 0; imonth<12; imonth++){  
+    monthlytemperaturestmp[imonth] = glacialindex*TemperaturesLgm[imonth] + (1-glacialindex)*TemperaturesPresentday[imonth];
+    //monthlyprectmp[imonth] = 1.5*pow(2,((monthlytemperaturestmp[imonth]-273.15-0)/10)); //equation from rob's paper
+    monthlyprectmp[imonth] = PrecipitationsPresentday[imonth];
+
+    /*Assign output pointer*/
+    *(monthlytemperaturesout+imonth) = monthlytemperaturestmp[imonth];
+    *(monthlyprecout+imonth) = monthlyprectmp[imonth];
+  }
+  // printf(" tempera %f\n",monthlytemperaturestmp[1]);
+}
Index: issm/trunk/src/c/shared/Elements/CoordinateSystemTransform.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/CoordinateSystemTransform.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Elements/CoordinateSystemTransform.cpp	(revision 13395)
@@ -22,5 +22,5 @@
 			case XYEnum:   numdofs+=2; break;
 			case XYZPEnum: numdofs+=4; break;
-			default: _error2_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
+			default: _error_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
 		}
 	}
@@ -67,5 +67,5 @@
 				break;
 			default:
-				_error2_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
+				_error_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
 		}
 	}
Index: issm/trunk/src/c/shared/Elements/PddSurfaceMassBalance.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/PddSurfaceMassBalance.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Elements/PddSurfaceMassBalance.cpp	(revision 13395)
@@ -43,5 +43,5 @@
   IssmDouble frzndd = 0.;  
   
-  IssmDouble tstar;                        // monthly mean surface temp
+  IssmDouble tstar;          // monthly mean surface temp
   IssmDouble Tsum= 0.;       // average summer (JJA) temperature
   IssmDouble Tsurf = 0.;     // average annual temperature    
@@ -61,5 +61,5 @@
   
   sconv=(rho_water/rho_ice)/12.; //rhow_rain/rhoi / 12 months
-  
+
   /*PDD constant*/
   siglim = 2.5*signorm; 
@@ -80,5 +80,5 @@
       if (tstar < PDup){
 	pd = 1.;
-	if (tstar >= -siglimc){ pd = pds[int(tstar/DT + siglim0c)];}}
+	if (tstar >= -siglimc){ pd = pds[reCast<int,IssmDouble>(tstar/DT + siglim0c)];}}
       else { 
 	pd = 0.;}
@@ -100,5 +100,5 @@
       if (tstar >= siglim) {pdd = pdd + tstar*deltm;}
       else if (tstar> -siglim){
-	pddsig=pdds[int(tstar/DT + siglim0)];
+	pddsig=pdds[reCast<int,IssmDouble>(tstar/DT + siglim0)];
 	pdd = pdd + pddsig*deltm;
 	frzndd = frzndd - (tstar-pddsig)*deltm;}
